## menhir 20190626

=== coq-menhirlib/src/Makefile ===
PWD := $(shell pwd)

COQINCLUDE := -R $(PWD) MenhirLib \

export

.PHONY: all clean install uninstall

all:

_CoqProject:
	@ $(MAKE) -f Makefile.coq --no-print-directory _CoqProject

all: _CoqProject
	@ $(MAKE) -f Makefile.coq --no-print-directory all

clean:
	@ $(MAKE) -f Makefile.coq --no-print-directory clean
	@ rm -f _CoqProject

# The role of DESTDIR is explained here:
# https://www.gnu.org/prep/standards/html_node/DESTDIR.html
# Basically, it is empty in a normal installation.
# A nonempty value can be used to perform a dummy installation
# in a different location.

CONTRIB := $(shell $(COQBIN)coqc -where)/user-contrib
TARGET  := $(DESTDIR)$(CONTRIB)/MenhirLib

install: all
	rm -rf $(TARGET)
	mkdir -p $(TARGET)
	install -m 644 *.v *.vo *.glob $(TARGET)

uninstall:
	rm -rf $(TARGET)

=== debian/changelog ===
menhir (20190626-6ubuntu1) eoan; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Fix build error due to exported V=1 function in launchpad
      buildd configuration (patch accepted upstream)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 27 Aug 2019 18:39:51 +0200

menhir (20190626-6) unstable; urgency=medium

  * Team upload
  * libmenhir-coq: add dependency to Coq ABI (Closes: #935873)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 27 Aug 2019 15:43:33 +0200

menhir (20190626-5ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Fix build error due to exported V=1 function in launchpad
      buildd configuration (patch accepted upstream)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Aug 2019 12:01:26 +0200

menhir (20190626-5) unstable; urgency=medium

  * Fix dependencies of the "library" test.

 -- Ralf Treinen <treinen@debian.org>  Wed, 21 Aug 2019 20:44:35 +0200

menhir (20190626-4) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Remove Samuel from Uploaders

  [ Ralf Treinen ]
  * Package tests:
    - add test for compilation with the menhir library
    - use directly the files from upstreams demos/ directory
    - make tests more verbose

 -- Ralf Treinen <treinen@debian.org>  Wed, 21 Aug 2019 20:17:35 +0200

menhir (20190626-3ubuntu2) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jul 2019 15:56:45 +0200

menhir (20190626-3ubuntu1) eoan; urgency=medium

  * Fix build error due to exported V=1 function in launchpad
    buildd configuration

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 26 Jul 2019 23:16:25 +0200

menhir (20190626-3) unstable; urgency=medium

  * Standards-Version 4.4.0 (no change)
  * Test coq: add dependency coq
  * Drop version contraint on build-dependency dh-ocaml

 -- Ralf Treinen <treinen@debian.org>  Thu, 25 Jul 2019 15:57:50 -0300

menhir (20190626-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ralf Treinen <treinen@debian.org>  Wed, 24 Jul 2019 20:26:11 -0300

menhir (20190626-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version 4.3.0 (no change)
  * New binary package: libmenhir-coq
  * New build-dependencies:
    - debhelper-compat(=12); drop file debian/compat
    - coq (needed for building libmenhir-coq)
  * Package libmenhir-ocaml-dev: Suggests ocaml-findlib
  * Override dh_dwz to use --no-dwz-multifile
  * As-installed tests:
    - Add test for libmenhir-coq (thanks a lot to Pierre Letouzey)
    - Rename test "calc" to "standalone", tighten test dependencies

 -- Ralf Treinen <treinen@debian.org>  Sun, 07 Jul 2019 21:32:31 +0200

=== debian/control ===
Source: menhir
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Mehdi Dogguy <mehdi@debian.org>,
  Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper-compat (=12),
  ocaml-nox (>= 4.02~),
  ocamlbuild,
  ocaml-findlib,
  dh-ocaml,
  coq
Standards-Version: 4.4.0
Homepage: http://gallium.inria.fr/~fpottier/menhir/
Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir
Vcs-Git: https://salsa.debian.org/ocaml-team/menhir.git

Package: menhir
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Suggests: menhir-doc
Description: Parser generator for OCaml
 Menhir is a LR(1) parser generator for the OCaml programming language.
 It is mostly compatible with the ocamlyacc parser generator provided with
 the OCaml system, and has the following enhancements over ocamlyacc:
  * it accepts LR(1) grammars,
  * it offers parameterized nonterminal symbols as well as a library of
    standard definitions,
  * it explains conflicts in terms of the grammar,
  * it allows grammar specifications to be split over multiple files and
    parametrized by OCaml modules,
  * it produces reentrant parsers.

Package: libmenhir-ocaml-dev
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Provides:
  ${ocaml:Provides}
Suggests:
  ocaml-findlib
Description: Menhir library for OCaml
 Menhir is a LR(1) parser generator for the OCaml programming language.
 It is mostly compatible with the ocamlyacc parser generator provided with
 OCaml, and has a number of enhancements over ocamlyacc.
 .
 This package contains the Menhir library for the OCaml programming language.
 It gives access to, among others, the following modules:
  * InfiniteArray: implements infinite arrays, that is, arrays
    that grow transparently upon demand.
  * RowDisplacement: compresses a two-dimensional table, where some
    values are considered insignificant, via row displacement.
  * Engine: LR parsing engine.

Package: menhir-doc
Section: doc
Replaces: menhir (<< 20170712-1)
Breaks: menhir (<< 20170712-1)
Architecture: all
Depends: ${misc:Depends}
Description: Documentation of the Menhir parser generator for OCaml
 Menhir is a LR(1) parser generator for the OCaml programming language.
 It is mostly compatible with the ocamlyacc parser generator provided with
 OCaml, and has a number of enhancements over ocamlyacc.
 .
 This package contains the Menhir manual as a pdf file, and the collection
 of Menhir examples.

Package: libmenhir-coq
Architecture: any
Depends:
  coq-${F:CoqABI},
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Recommends: menhir
Description: Support library for verified Coq parsers produced by Menhir
 The Menhir parser generator, when invoked with the --coq option, produces
 parser code in the Coq language.
 .
 These parsers must be linked against this library, which provides
 both an interpreter (which allows running the generated parser) and
 a validator (which allows verifying, at parser construction time,
 that the generated parser is correct and complete with respect to
 the grammar).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/coq/coqvars.mk

DESTDIR := $(CURDIR)/debian/tmp
export OCAMLFIND_DESTDIR := $(DESTDIR)/$(OCAML_STDLIB_DIR)
BEST := native
ifneq ($(OCAML_BEST),opt)
BEST = byte
endif

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) TARGET=$(BEST) PREFIX=/usr
	$(MAKE) -C coq-menhirlib

override_dh_auto_clean:
	$(MAKE) -C src/ clean PREFIX=$(DESTDIR)/usr

override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR)
	$(MAKE) TARGET=$(BEST) PREFIX=$(DESTDIR)/usr install
	$(MAKE) -C coq-menhirlib DESTDIR=$(DESTDIR) install

override_dh_installexamples:
	dh_installexamples
	if [ -d debian/menhir-doc/usr/share/doc/menhir/examples ]; \
	then \
	  find debian/menhir-doc/usr/share/doc/menhir/examples \
	    -name .gitignore -delete ; \
	fi

override_dh_dwz:
	dh_dwz --no-dwz-multifile

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:

override_dh_gencontrol:
	dh_gencontrol -- -VF:CoqABI="$(COQ_ABI)"

=== debian/tests/control ===
Tests: standalone
Depends: menhir, ocaml-nox, ocaml-findlib, ocamlbuild

Tests: library
Depends: libmenhir-ocaml-dev, menhir, ocaml-nox, ocaml-findlib, ocamlbuild

Tests: coq
Depends: menhir, libmenhir-coq, coq

## menhir 20200123

=== src/Makefile ===
# [make] compiles Menhir.

.PHONY: all
all:
	@ make -C .. $@

=== coq-menhirlib/src/Makefile ===
--- 
+++ 
@@ -2,17 +2,15 @@
 
 COQINCLUDE := -R $(PWD) MenhirLib \
 
-export
+export COQINCLUDE
 
 .PHONY: all clean install uninstall
 
-all:
+all: _CoqProject
+	@ $(MAKE) -f Makefile.coq --no-print-directory all
 
 _CoqProject:
 	@ $(MAKE) -f Makefile.coq --no-print-directory _CoqProject
-
-all: _CoqProject
-	@ $(MAKE) -f Makefile.coq --no-print-directory all
 
 clean:
 	@ $(MAKE) -f Makefile.coq --no-print-directory clean
@@ -24,8 +22,8 @@
 # A nonempty value can be used to perform a dummy installation
 # in a different location.
 
-CONTRIB := $(shell $(COQBIN)coqc -where)/user-contrib
-TARGET  := $(DESTDIR)$(CONTRIB)/MenhirLib
+CONTRIB = $(shell $(COQBIN)coqc -where)/user-contrib
+TARGET  = $(DESTDIR)$(CONTRIB)/MenhirLib
 
 install: all
 	rm -rf $(TARGET)

=== src/stage2/Makefile ===
# The directory used by dune to mirror this directory.

BUILD_DIR := ../../_build/default/src/stage2

# [make update] is used under the programmer's manual control, after the
# grammar in [parser.mly] has been modified.

# It updates the file [parserMessages.messages] with new error states (if
# necessary) and with new auto-generated comments for all error states.

.PHONY: update
update:
	@ dune build --force parserMessages.messages.updated
	@ cp $(BUILD_DIR)/parserMessages.messages.updated parserMessages.messages

# [make strip] strips away the auto-generated comments found in the file
# parserMessages.messages. It is typically used after [make update], which
# creates many such comments.

.PHONY: strip
strip:
	@ sed -e "/^##/d" -i.bak parserMessages.messages
	@ rm parserMessages.messages.bak

=== debian/changelog ===
menhir (20200123-2) unstable; urgency=medium

  * Removal of coq-menhirlib from this source package:
    - add coq-menhirlib to the gbp import filter
    - clean debian/rules
    - remove coq-menhirlib from debian/control
    - drop build-dependency on coq
    - drop debian/libmenhir-coq.install
    - remove stanzas relating to coq-menhirlib from debian/copyright
    - drop as-installed test coq, and its support files
    - add an explanation in debian/README.source.
    
 -- Ralf Treinen <treinen@debian.org>  Thu, 27 Feb 2020 22:13:34 +0100

menhir (20200123-1) unstable; urgency=medium

  * New upstream version
  * Drop patch demos-enable-bytecode as the collection of demos is no longer
    part of upstream
  * Build-dependencies:
    - tighten version of ocaml-nox
    - drop ocamlbuild and ocaml-findlib
    - add ocaml-dune
  - debian/rules:
    - switch to the new build system using dune
    - drop override for dh_auto_test which is no longer needed
    - drop override for dh_dwz which is no longer needed
  - Installation:
    - install menhir.1 through debian/menhir.manpages
    - drop installation of empty directory usr/menhir/share
    - upstream installs documentation in /usr/doc
    - no more examples to install
    - create file d/not-installed, listing redundant CHANGES.md, LICENCE.md,
      README.md files
  * as-installed tests: since upstream does not distribute the demos any
    longer we use our own copy of relevant testcases in debian/tests.
  * Standards-version 4.5.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sat, 08 Feb 2020 10:50:13 +0100

menhir (20190924-1) unstable; urgency=medium

  * New upstream version
  * Set Multi-Arch:foreign for the menhir-doc package
  * Standards-Version: 4.4.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sat, 02 Nov 2019 11:51:19 +0100

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,10 @@
   Ralf Treinen <treinen@debian.org>
 Build-Depends:
   debhelper-compat (=12),
-  ocaml-nox (>= 4.02~),
-  ocamlbuild,
-  ocaml-findlib,
+  ocaml-nox (>= 4.02.3~),
+  ocaml-dune (>= 2.0),
   dh-ocaml,
-  coq
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir
 Vcs-Git: https://salsa.debian.org/ocaml-team/menhir.git
@@ -65,6 +63,7 @@
 Breaks: menhir (<< 20170712-1)
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Documentation of the Menhir parser generator for OCaml
  Menhir is a LR(1) parser generator for the OCaml programming language.
  It is mostly compatible with the ocamlyacc parser generator provided with
@@ -72,21 +71,3 @@
  .
  This package contains the Menhir manual as a pdf file, and the collection
  of Menhir examples.
-
-Package: libmenhir-coq
-Architecture: any
-Depends:
-  coq-${F:CoqABI},
-  ${ocaml:Depends},
-  ${shlibs:Depends},
-  ${misc:Depends}
-Recommends: menhir
-Description: Support library for verified Coq parsers produced by Menhir
- The Menhir parser generator, when invoked with the --coq option, produces
- parser code in the Coq language.
- .
- These parsers must be linked against this library, which provides
- both an interpreter (which allows running the generated parser) and
- a validator (which allows verifying, at parser construction time,
- that the generated parser is correct and complete with respect to
- the grammar).

=== debian/rules ===
#!/usr/bin/make -f

DESTDIR := $(CURDIR)/debian/tmp

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dune clean

override_dh_auto_build:
	dune build @install

override_dh_auto_install:
	DESTDIR=$(DESTDIR) dune install 

override_dh_missing:
	dh_missing --fail-missing

## menhir 20200624

=== fix/Makefile ===
# ------------------------------------------------------------------------------

# The name of the library.
THIS     := fix

# The version number is automatically set to the current date,
# unless DATE is defined on the command line.
DATE     := $(shell /bin/date +%Y%m%d)

# The repository URL (https).
REPO     := https://gitlab.inria.fr/fpottier/$(THIS)

# The archive URL (https).
ARCHIVE  := $(REPO)/repository/$(DATE)/archive.tar.gz

# ------------------------------------------------------------------------------

.PHONY: all
all:
	dune build -p $(THIS)

# [make test] runs all tests.

# Some tests require the following opam packages:
#   regenerate

.PHONY: test
test:
	dune build @runtest

# [make versions] compiles Fix under many versions of OCaml, whose
# list is specified in the file dune-workspace.versions.

# This requires appropriate opam switches to exist. A missing switch
# can be created like this:
#   opam switch create 4.03.0

.PHONY: versions
versions:
	@ dune build --workspace dune-workspace.versions -p $(THIS)

.PHONY: install
install: all
	dune install -p $(THIS)

.PHONY: clean
clean:
	rm -f *~ src/*~
	dune clean

.PHONY: uninstall
uninstall:
	ocamlfind remove $(THIS) || true

.PHONY: reinstall
reinstall: uninstall
	@ make install

.PHONY: show
show: reinstall
	@ echo "#require \"fix\";;\n#show Fix;;" | ocaml

.PHONY: pin
pin:
	opam pin add $(THIS) .

.PHONY: unpin
unpin:
	opam pin remove $(THIS)

HEADACHE := headache
LIBHEAD  := $(shell pwd)/headers/library-header
FIND     := $(shell if command -v gfind >/dev/null ; then echo gfind ; else echo find ; fi)

.PHONY: headache
headache:
	@ $(FIND) src -regex ".*\.ml\(i\|y\|l\)?" \
	    -exec $(HEADACHE) -h $(LIBHEAD) "{}" ";"

.PHONY: release
release:
# Make sure the current version can be compiled and installed.
	@ make uninstall
	@ make clean
	@ make install
# Check the current package description.
	@ opam lint
# Check if everything has been committed.
	@ if [ -n "$$(git status --porcelain)" ] ; then \
	    echo "Error: there remain uncommitted changes." ; \
	    git status ; \
	    exit 1 ; \
	  else \
	    echo "Now making a release..." ; \
	  fi
# Create a git tag.
	@ git tag -a $(DATE) -m "Release $(DATE)."
# Upload. (This automatically makes a .tar.gz archive available on gitlab.)
	@ git push
	@ git push --tags

.PHONY: publish
publish:
# Publish an opam description.
	@ opam publish -v $(DATE) $(THIS) $(ARCHIVE) .

MENHIR_WORKING_COPY=$(HOME)/dev/menhir

.PHONY: menhir
menhir:
# Check if this is the menhir branch.
	@ if [ "$$(git symbolic-ref --short HEAD)" != "menhir" ] ; then \
	  echo "Error: this is not the menhir branch." ; \
	  git branch ; \
	  exit 1 ; \
	fi
# Copy our source files to the Menhir repository.
	@ (cd .. && cp -r fix $(MENHIR_WORKING_COPY))
# Remove a number of unneeded subdirectories.
	@ (cd $(MENHIR_WORKING_COPY)/fix && rm -rf .git demos misc)

=== debian/changelog ===
menhir (20200624-1) unstable; urgency=medium

  * New upstream release.
  * d/rules: include ocamlvars.mk to obtain override of dh_dwz
  * Dehelper compatibility level 13:
    - drop override of dh_missing which is no longer needed
  * d/copyright: fix spelling of "src/StaticVersion.mli"
  * Bump version of build-dependency dune, as indicated by upstream's opam file
  * Set Rules-Requires-Root=no

 -- Ralf Treinen <treinen@debian.org>  Sat, 22 Aug 2020 18:46:28 +0200

menhir (20200123-3) unstable; urgency=medium

  * patch menhirLib: fix the value returned by --suggest-menhirLib
    (closes: #955494)

 -- Ralf Treinen <treinen@debian.org>  Thu, 02 Apr 2020 12:22:45 +0200

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,12 @@
   Mehdi Dogguy <mehdi@debian.org>,
   Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper-compat (=12),
+  debhelper-compat (=13),
   ocaml-nox (>= 4.02.3~),
-  ocaml-dune (>= 2.0),
+  ocaml-dune (>= 2.2.0),
   dh-ocaml,
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir
 Vcs-Git: https://salsa.debian.org/ocaml-team/menhir.git

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+include /usr/share/ocaml/ocamlvars.mk
 
 DESTDIR := $(CURDIR)/debian/tmp
 
@@ -13,6 +15,3 @@
 
 override_dh_auto_install:
 	DESTDIR=$(DESTDIR) dune install 
-
-override_dh_missing:
-	dh_missing --fail-missing

## menhir 20201216

=== fix/Makefile ===
--- 
+++ 
@@ -68,6 +68,16 @@
 unpin:
 	opam pin remove $(THIS)
 
+.PHONY: doc
+doc:
+	dune build @doc
+	@echo You can find the documentation in _build/default/_doc/_html/index.html
+
+.PHONY: export
+export: doc
+	ssh yquem.inria.fr rm -rf public_html/$(THIS)/doc
+	scp -r _build/default/_doc/_html yquem.inria.fr:public_html/$(THIS)/doc
+
 HEADACHE := headache
 LIBHEAD  := $(shell pwd)/headers/library-header
 FIND     := $(shell if command -v gfind >/dev/null ; then echo gfind ; else echo find ; fi)
@@ -105,6 +115,7 @@
 	@ opam publish -v $(DATE) $(THIS) $(ARCHIVE) .
 
 MENHIR_WORKING_COPY=$(HOME)/dev/menhir
+FIX_COPY=$(MENHIR_WORKING_COPY)/fix
 
 .PHONY: menhir
 menhir:
@@ -115,6 +126,7 @@
 	  exit 1 ; \
 	fi
 # Copy our source files to the Menhir repository.
-	@ (cd .. && cp -r fix $(MENHIR_WORKING_COPY))
+	@ rm -rf $(FIX_COPY)
+	@ cp -r $(shell pwd) $(FIX_COPY)
 # Remove a number of unneeded subdirectories.
-	@ (cd $(MENHIR_WORKING_COPY)/fix && rm -rf .git demos misc)
+	@ (cd $(FIX_COPY) && rm -rf .git demos misc)

=== debian/changelog ===
menhir (20201216-1) unstable; urgency=medium

  * New upstream release

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2021 21:01:58 +0100

menhir (20201201-1) unstable; urgency=medium

  * New upstream version.
  * Standards-version 4.5.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sun, 06 Dec 2020 10:29:09 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
   ocaml-nox (>= 4.02.3~),
   ocaml-dune (>= 2.2.0),
   dh-ocaml,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir

=== debian/tests/control ===
Tests: standalone
Depends: menhir, ocaml-nox, ocaml-findlib, ocamlbuild

Tests: library
Depends: libmenhir-ocaml-dev, menhir, ocaml-nox, ocaml-findlib, ocamlbuild

## menhir 20210929

=== doc/Makefile ===
.PHONY: all loop clean

export TEXINPUTS=.:

DEPS = $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(wildcard *.mly)

all: manual.pdf manual.html

%.pdf: %.tex $(DEPS)
	pdflatex $*
	bibtex $*
	pdflatex $*
	pdflatex $*

manual.html: manual.tex $(DEPS) $(wildcard *.hva)
	hevea -fix manual.tex
#
# Hevea interprets 'tabbing' environment in a way
# that creates spacing errors in the rendered output
# of "textual version of derivation trees": it
# asks for (padding:0px;) while the TeX rendering
# inserts spacing between columns. Change this
# to {padding:1px;}
	sed -i.bak -e "s/cellpadding0/cellpadding1/" manual.html && rm manual.html.bak
#
# Note: hevea generates images manual00{1,2,3}.png for the tikz pictures
# present in the manual.

loop:
	latexmk -pdf -pvc manual

clean:
	@ rm -f `cat .gitignore`

=== coq-menhirlib/src/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 PWD := $(shell pwd)
 
-COQINCLUDE := -R $(PWD) MenhirLib \
+COQINCLUDE := -R . MenhirLib \
 
 export COQINCLUDE
 
@@ -22,7 +22,7 @@
 # A nonempty value can be used to perform a dummy installation
 # in a different location.
 
-CONTRIB = $(shell $(COQBIN)coqc -where)/user-contrib
+CONTRIB = $(shell $(COQBIN)coqc -where  | tr -d '\r' | tr '\\' '/')/user-contrib
 TARGET  = $(DESTDIR)$(CONTRIB)/MenhirLib
 
 install: all

=== fix/src/Makefile ===
.PHONY: all
all:
	dune build @check
# This is enough to type-check the code in this directory,
# and is much faster than "make -C .. all".

=== debian/changelog ===
menhir (20210929-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:20:39 +0100

menhir (20210929-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - fix file patterns for the runtime library which has moved to lib/
    - remove some licences that are no longer used
  * Standards-version 4.6.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Fri, 01 Oct 2021 23:02:46 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
   ocaml-nox (>= 4.02.3~),
   ocaml-dune (>= 2.2.0),
   dh-ocaml,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir

=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,4 @@
 	dune build @install
 
 override_dh_auto_install:
-	DESTDIR=$(DESTDIR) dune install 
+	DESTDIR=$(DESTDIR) dune install --prefix=usr --libdir=lib/ocaml

=== debian/watch ===
version=4

#http://pauillac.inria.fr/~fpottier/menhir/menhir-(.*)\.tar\.gz
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/menhir.*\.tar\.gz/menhir-$1\.tar\.gz/g \
  https://gitlab.inria.fr/fpottier/menhir/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*

## menhir 20220210+ds

=== doc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-.PHONY: all loop clean
+.PHONY: all loop clean check
 
 export TEXINPUTS=.:
 
@@ -31,3 +31,12 @@
 
 clean:
 	@ rm -f `cat .gitignore`
+
+CHECK := manual.tex
+
+check:
+	@ for f in $(CHECK) ; do \
+	  aspell --mode=tex --lang=en_US --encoding=utf-8 \
+	         --home-dir=. --personal=.aspell.en.pws \
+	         check $$f ; \
+	done

=== debian/changelog ===
menhir (20220210+ds-2) unstable; urgency=medium

  * Prepare for upload to unstable.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 13 May 2022 13:47:21 +0200

menhir (20220210+ds-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Make sure the doc is built.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 18 Mar 2022 10:43:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: ocaml
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
-Uploaders:
-  Mehdi Dogguy <mehdi@debian.org>,
-  Ralf Treinen <treinen@debian.org>
-Build-Depends:
-  debhelper-compat (=13),
-  ocaml-nox (>= 4.02.3~),
-  ocaml-dune (>= 2.2.0),
-  dh-ocaml,
+Uploaders: Mehdi Dogguy <mehdi@debian.org>, Ralf Treinen <treinen@debian.org>
+Build-Depends: debhelper-compat (=13),
+               dh-ocaml,
+               hevea,
+               imagemagick,
+               ocaml-dune (>= 2.2.0),
+               ocaml-nox (>= 4.02.3~),
+               texlive-fonts-recommended,
+               texlive-latex-extra
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
@@ -18,10 +19,7 @@
 
 Package: menhir
 Architecture: any
-Depends:
-  ${ocaml:Depends},
-  ${shlibs:Depends},
-  ${misc:Depends}
+Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Suggests: menhir-doc
 Description: Parser generator for OCaml
  Menhir is a LR(1) parser generator for the OCaml programming language.
@@ -37,14 +35,9 @@
 
 Package: libmenhir-ocaml-dev
 Architecture: any
-Depends:
-  ${ocaml:Depends},
-  ${shlibs:Depends},
-  ${misc:Depends}
-Provides:
-  ${ocaml:Provides}
-Suggests:
-  ocaml-findlib
+Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
+Provides: ${ocaml:Provides}
+Suggests: ocaml-findlib
 Description: Menhir library for OCaml
  Menhir is a LR(1) parser generator for the OCaml programming language.
  It is mostly compatible with the ocamlyacc parser generator provided with

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,7 @@
 	dune clean
 
 override_dh_auto_build:
+	make -C doc
 	dune build @install
 
 override_dh_auto_install:

=== debian/tests/control ===
Tests: standalone
Depends: menhir, ocaml-findlib, ocaml-nox, ocamlbuild

Tests: library
Depends: libmenhir-ocaml-dev, menhir, ocaml-findlib, ocaml-nox, ocamlbuild

## menhir 20220210+ds1

=== debian/changelog ===
menhir (20220210+ds1-1) unstable; urgency=medium

  * Team upload
  * Properly repack upstream sources, without coq-menhirlib
  * Use ocaml_dune DH buildsystem (Closes: #1042097)
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Wed, 26 Jul 2023 21:36:14 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Mehdi Dogguy <mehdi@debian.org>, Ralf Treinen <treinen@debian.org>
 Build-Depends: debhelper-compat (=13),
-               dh-ocaml,
+               dh-ocaml (>= 1.2.2),
                hevea,
                imagemagick,
                ocaml-dune (>= 2.2.0),
-               ocaml-nox (>= 4.02.3~),
+               ocaml,
                texlive-fonts-recommended,
                texlive-latex-extra
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

override_dh_auto_build:
	make -C doc
	dh_auto_build

## menhir 20230608+ds

=== debian/changelog ===
menhir (20230608+ds-1build2) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 Nov 2023 15:55:11 +0100

menhir (20230608+ds-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Nov 2023 00:13:31 +0100

menhir (20230608+ds-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release
  * Fix debian/watch
  * Fix cleaning (Closes: #1046147)

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on ocaml-nox (>= 4.02.3~).
    + menhir-doc: Drop conflict with removed package menhir (<< 20170712-1) in
      Replaces.
    + menhir-doc: Drop conflict with removed package menhir (<< 20170712-1) in
      Breaks.
  * Use secure URI in Homepage field.

 -- Stéphane Glondu <glondu@debian.org>  Sun, 27 Aug 2023 06:34:07 +0200

## menhir 20231231+ds

=== debian/changelog ===
menhir (20231231+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Feb 2024 14:22:52 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                texlive-latex-extra
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://gallium.inria.fr/~fpottier/menhir/
+Homepage: https://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir
 Vcs-Git: https://salsa.debian.org/ocaml-team/menhir.git
 
@@ -53,8 +53,6 @@
 
 Package: menhir-doc
 Section: doc
-Replaces: menhir (<< 20170712-1)
-Breaks: menhir (<< 20170712-1)
 Architecture: all
 Depends: ${misc:Depends}
 Multi-Arch: foreign

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,5 @@
 %:
 	dh $@ --with ocaml --buildsystem ocaml_dune
 
-override_dh_auto_build:
+execute_before_dh_auto_build:
 	make -C doc
-	dh_auto_build

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds\d*//g,repacksuffix=+ds \
https://gitlab.inria.fr/fpottier/menhir/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*

## menhir 20240715+ds

=== debian/changelog ===
menhir (20240715+ds-1build2) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 21:16:28 +0200

menhir (20240715+ds-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 13:43:31 +0100

menhir (20240715+ds-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.7.0

  [ Julien Puydt ]
  * Fix debian/watch.

 -- Stéphane Glondu <glondu@debian.org>  Tue, 20 Aug 2024 08:32:20 +0200

menhir (20231231+ds-2) unstable; urgency=medium

  * Team upload
  * Add support for a different OCaml stdlib dir

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Aug 2024 06:37:35 +0200

## menhir 20250903+ds

=== debian/changelog ===
menhir (20250903+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 09 Sep 2025 16:09:54 +0200

## menhir 20250912%2Bds

=== demos/calc-syntax-errors/Makefile ===
include ../Makefile.demo
include Makefile.messages.maintenance

clean::
	rm -f *.bak

## menhir 20250912+ds

=== cst/Makefile ===
.PHONY: all
all:
	make -C .. $@

=== doc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-.PHONY: all loop clean check
+.PHONY: all view loop clean check
 
 export TEXINPUTS=.:
 
@@ -26,6 +26,9 @@
 # Note: hevea generates images manual00{1,2,3}.png for the tikz pictures
 # present in the manual.
 
+view:
+	latexmk -pdf -pv manual
+
 loop:
 	latexmk -pdf -pvc manual

=== sdk/Makefile ===
# [make] compiles menhirSdk.

.PHONY: all
all:
	@ dune build @check

=== src/Makefile ===
# [make] compiles Menhir.

.PHONY: all
all:
	@ dune build @check

=== demos/calc-mini/Makefile ===
include ../Makefile.demo

=== demos/calc-unparsing-benchmark/Makefile ===
include ../Makefile.demo

.PHONY: bench
bench:
	dune exec ./main.exe -- time alloc samples -quota 10

.PHONY: once
once:
	dune exec ./main.exe -- time alloc -quota 1x

=== demos/coq-minicalc/Makefile ===
MENHIR            := menhir
MENHIRFLAGS       := --coq

Makefile.coq:
	@ coq_makefile -f _CoqProject -o Makefile.coq

Parser.v : Parser.vy
	@ $(MENHIR) $(MENHIRFLAGS) $<

ifneq ($(MAKECMDGOALS),clean)
-include Makefile.coq
endif

.PHONY: clean
clean::
	@ git clean -fdX

=== demos/coq-syntax-errors/Makefile ===
MENHIR            := dune exec menhir --
MENHIRFLAGS       := --coq --coq-no-version-check

# [make all] compiles this demo.

# We first generate Parser.v and ParserMessages.ml (via two separate
# invocations of menhir), then generate extraction/*.ml (by invoking
# Coq), then compile the OCaml code (by using dune).

.PHONY: all
all: Parser.v ParserMessages.ml extraction/Parser.ml
	@ dune build . --no-print-directory

# [make test] tests just this demo.

.PHONY: test
test: all
	@ dune build --force --display short @essai --no-print-directory

# [make clean] cleans up just this demo.

.PHONY: clean
clean::
	@ git clean -fdX

# Auxiliary targets.

Parser.v: Parser.vy
	@ $(MENHIR) $(MENHIRFLAGS) $<

ParserMessages.ml: parserMessages.messages Parser.vy
	@ $(MENHIR) $(MENHIRFLAGS) Parser.vy --compile-errors parserMessages.messages > ParserMessages.ml

extraction/Parser.ml: Parser.v
	@ coqc -Q . MiniCalc Parser.v
	@ coqtop -Q . MiniCalc -batch -load-vernac-source Extraction.v

# Rules for maintaining the .messages file.

include Makefile.messages.maintenance

=== src/stage2/Makefile ===
--- 
+++ 
@@ -5,8 +5,8 @@
 # [make update] is used under the programmer's manual control, after the
 # grammar in [parser.mly] has been modified.
 
-# It updates the file [parserMessages.messages] with new error states (if
-# necessary) and with new auto-generated comments for all error states.
+# It updates the file [parserMessages.messages] with new auto-generated
+# comments for all error states.
 
 .PHONY: update
 update:

=== benchmarks/template/backends/Makefile ===
BACKENDS := $(patsubst %.flags,%,$(wildcard *.flags))

# Copy TEMPLATE, with a suitable replacement of FLAGS,
# under the name [dune] in every .backend directory.

.PHONY: all
all:
	@ for b in $(BACKENDS) ; do \
	    mkdir -p $$b.backend && \
	    sed -e "s/FLAGS/$$(cat $$b.flags)/" TEMPLATE > $$b.backend/dune ; \
	  done

# Remove every .backend directory.

.PHONY: clean
clean:
	@ rm -rf *.backend

=== demos/ocamlbuild/calc-alias/Makefile ===
.PHONY: all clean test

MENHIR          := menhir

MENHIRFLAGS     := --infer

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS)"

MAIN            := calc

all:
	$(OCAMLBUILD) $(MAIN).native

clean:
	rm -f *~ .*~
	$(OCAMLBUILD) -clean

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./$(MAIN).native

=== debian/changelog ===
menhir (20250912+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 16 Sep 2025 02:04:20 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                ocaml,
                texlive-fonts-recommended,
                texlive-latex-extra
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gallium.inria.fr/~fpottier/menhir/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir

=== debian/tests/control ===
Tests: standalone
Depends: menhir, ocaml-findlib, ocaml, ocamlbuild

Tests: library
Depends: libmenhir-ocaml-dev, menhir, ocaml-findlib, ocaml, ocamlbuild

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds\d*//g,repacksuffix=+ds,searchmode=plain \
https://gitlab.inria.fr/fpottier/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
